package de.fraunhofer.iem.dataprovider.gitlab

import de.fraunhofer.iem.dataprovider.logger.getLogger
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

data class RepositoryChangedDto(val repoId: Long)
@RestController
@RequestMapping("/gitlab")
class GitlabController(private val gitlabService: GitlabService) {

    private val logger = getLogger(javaClass)

    @PostMapping("/repoChanged")
    fun repoChanged(@RequestBody repositoryChangedDto: RepositoryChangedDto) {
        logger.info("Repo changed POST request for ID ${repositoryChangedDto.repoId} received.")
        gitlabService.queryRepo(repositoryChangedDto.repoId)
    }
}